@setlocal
@ECHO OFF
:: *********************************************************************
:: GWGCC.BAT -> create Windows GUI CON DLL using MinGW gcc
:: *********************************************************************
:: Parameter 1 source file name no extension
:: Parameter 2 should be -m32 -m64
:: Parameter 3 should be CON for console or GUI windows DLL for dynamic link library
:: *********************************************************************

:: IF[%1]==[] GOTO usage
:: get just file name. RadAsm3 passes complete path with non project files
:: ----------------------------
 SET F=%~n1
:: ----------------------------
IF [%2] == [] GOTO usage
IF [%3] == []   GOTO usage

IF /I [%3] == [CON] (
  SET GCCCFL= -Wno-write-strings -static-libgcc -pipe -mconsole %2 -w -s -O2
  SET FTYPE="Windows Console App"
  SET OUTFILE="%F%.EXE"
)

IF /I [%3] == [GUI] (
  SET GCCCFL= -Wno-write-strings -static-libgcc -pipe -mwindows %2 -w -s -O2
  SET FTYPE="Windows Gui App"
  SET OUTFILE="%F%.EXE"
REM  ftool.exe "%F%.c" "static PCHAR   *g_argv;" "" -l
REM   ftool.exe "%F%.c" "static int     g_argc;" "" -l 
REM  ftool.exe "%F%.c""  g_argc = argc;" "" -l
REM  ftool.exe "%F%.c""  g_argv = argv;" "" -l
REM  ftool.exe "%F%.C" "static char *LowCase;" "char *LowCase;"  -l
)

IF /I [%3] == [DLL] (
  SET GCCCFL= -Wno-write-strings -static-libgcc -pipe -shared -w -s -O2 %2 -Wl,--add-stdcall-alias,--output-def,"%F%.def",--out-implib,"lib%F%.a" -s
  SET FTYPE="Windows Dll"
    SET OUTFILE="%F%.DLL"
)

IF NOT DEFINED GCCCFL GOTO usage
IF NOT EXIST %F%.c GOTO usage
:: --------------------------------------------------------------------
:: MINGW is set in RadAsm3 Environment Options
::--------------------------------------------------------------------
SET PATH=%MINGW%\bin;%PATH%
SET INCLUDE=%MINGW%\include;%MINGW%\include\sys
SET LIB=%MINGW%\lib
:: SET GCCCFL= -Wno-write-strings -static-libgcc -pipe %CORG% %2 -w -s -O2

REM ftool.exe "%F%.c" "liblist"
REM CALL libs.bat
SET LIBS=-lmingw32 -lgcc -lkernel32 -luser32 -lgdi32 -lcomctl32 -ladvapi32 -lwinspool -lshell32 -lole32 -loleaut32 -luuid -lodbc32 -lodbccp32 -lwinmm -lcomdlg32 -limagehlp -lversion 

IF [%2] == [-m32] (
SET RESTARGET=-Fpe-i386
)

::--------------------------------------------------------------
:: always use the %F%.rc file in the Res Directory if it exists
:: this should handle both projects and individual files with resources

IF EXIST res\%F%.rc (
  ECHO Compiling resources.....
  cd res
REM  windres -I. -DWINVER=0x0400 %RESTARGET% -i "%F%.rc" -o "%F%res.o"
  windres -I. %WIN_VER% %RESTARGET% -i "%F%.rc" -o "%F%res.o"
  SET GRES=res\%F%res.o
  cd ..
) ELSE (
  IF EXIST %F%.rc (
    ECHO Compiling resources.....
REM    windres -I. -DWINVER=0x0400 %RESTARGET% -i "%F%.rc" -o "%F%res.o"
    windres -I. %WIN_VER% %RESTARGET% -i "%F%.rc" -o "%F%res.o"
    SET GRES=%F%res.o
  )
)
::--------------------------------------------------------------

::-------------------------------
IF NOT [%4]==[-lbcxrt] cfix "%F%.c"
::-------------------------------

ECHO Compiling "%F%.c" to an  %2 %FTYPE%

gcc %GCCCFL% "%F%.c" %WIN_VER% -o %OUTFILE% %GRES% %4 %5 %6 %7 %8 %9 %LIBS%




ECHO Finished!
IF EXIST %GRES% del "%GRES%"
IF EXIST %F%.o del "%F%.o"
IF EXIST libs.bat del libs.bat
GOTO done
:usage
ECHO **************************************************************
ECHO  Usage:  GCC.BAT MainFile  -m32 or-m64 CON or GUI ExtraFile1 ExtraFile2
ECHO  Note:   ExtraFiles can be .a (import or static libraries) and
ECHO          .o (objectfiles)
ECHO     Use this batch file to easily create your gcc program
ECHO **************************************************************
:done
endlocal
