@setlocal
@ECHO OFF
:: *********************************************************************
:: GC++.BAT -> create Windows GUI, CON or DLL using MinGW g++
:: *********************************************************************
:: Parameter 1 source file name no extension
:: Parameter 2 should be -m32 -m64
:: Parameter 3 should be CON for console GUI for windows and dll for ...
:: *********************************************************************

:: IF[%1]==[] GOTO usage
:: get just file name. RadAsm3 passes complete path with non project files
:: ----------------------------
 SET F=%~n1
:: ----------------------------
IF [%2] == [] GOTO usage
IF [%3] == []   GOTO usage

IF /I [%3] == [CON] (
  SET GCCCFL= -Wno-write-strings -static-libgcc -pipe -mconsole %2 -w -s -O2
  SET FTYPE="Windows Console App"
)

IF /I [%3] == [GUI] (
  SET GCCCFL= -Wno-write-strings -static-libgcc -pipe -mwindows %2 -w -s -O2
  SET FTYPE="Windows Gui App"
REM   ftool.exe "%F%.cpp" "static PCHAR   *g_argv;" "" -l
REM   ftool.exe "%F%.cpp" "static int     g_argc;" "" -l  
)

IF /I [%3] == [DLL] (
  SET GCCCFL= -Wno-write-strings -static-libgcc -pipe -shared -w -s -O2 %2 -Wl,--add-stdcall-alias,--output-def,"%F%.def",--out-implib,"lib%F%.a" -s
  SET FTYPE="Windows Dll"
)

IF NOT DEFINED GCCCFL GOTO usage
IF NOT EXIST %F%.cpp GOTO usage
:: --------------------------------------------------------------------
:: MINGW is set in RadAsm3 Environment Options
::--------------------------------------------------------------------
SET PATH=%MINGW%\bin;%PATH%
SET INCLUDE=%MINGW%\include;%MINGW%\include\sys
SET LIB=%MINGW%\lib
:: SET GCCCFL= -Wno-write-strings -static-libgcc -pipe %CORG% %2 -w -s -O2

REM ftool.exe "%F%.cpp" "liblist"
REM CALL libs.bat
SET LIBS=-lmingw32 -lgcc -lkernel32 -luser32 -lgdi32 -lcomctl32 -ladvapi32 -lwinspool -lshell32 -lole32 -loleaut32 -luuid -lodbc32 -lodbccp32 -lwinmm -lcomdlg32 -limagehlp -lversion 

IF [%2] == [-m32] (
SET RESTARGET=-Fpe-i386
)

::--------------------------------------------------------------
:: always use the %F%.rc file in the Res Directory if it exists
:: this should handle both projects and individual files with resources

IF EXIST res\%F%.rc (
  ECHO Compiling resources.....
  cd res
  windres -I. %WIN_VER% %RESTARGET% -i "%F%.rc" -o "%F%res.o"
  SET GRES=res\%F%res.o
  cd ..
) ELSE (
  IF EXIST %F%.rc (
    ECHO Compiling resources.....
    windres -I. %WIN_VER% %RESTARGET% -i "%F%.rc" -o "%F%res.o"
    SET GRES=%F%res.o
  )
)
::--------------------------------------------------------------


ECHO Compiling "%F%.cpp" to an  %2 %FTYPE%
IF /I [%3] == [DLL] (
g++ %GCCCFL% "%F%.cpp" %WIN_VER% -o"%F%.dll" %GRES% %4 %5 %6 %7 %8 %9 %LIBS%
) ELSE (
g++ %GCCCFL% "%F%.cpp" %WIN_VER% -o"%F%.exe" %GRES% %4 %5 %6 %7 %8 %9 %LIBS%
)



ECHO Finished!
IF EXIST %GRES% del "%GRES%"
IF EXIST %F%.o del "%F%.o"
IF EXIST libs.bat del libs.bat
GOTO done
:usage
ECHO **************************************************************
ECHO  Usage:  GC++.BAT MainFile  -m32 or-m64 CON or GUI ExtraFile1 ExtraFile2
ECHO  Note:   ExtraFiles can be .a (import or static libraries) and
ECHO          .o (objectfiles)
ECHO     Use this batch file to easily create your g++ program
ECHO **************************************************************
:done
endlocal
